"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _reactRedux = require("react-redux");
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _APIController = _interopRequireDefault(require("./APIController.react"));
var _Loading = _interopRequireDefault(require("./components/core/Loading.react"));
var _Toolbar = _interopRequireDefault(require("./components/core/Toolbar.react"));
var _Reloader = _interopRequireDefault(require("./components/core/Reloader.react"));
var _config = _interopRequireDefault(require("./config"));
var _index = require("./actions/index");
var _ramda = require("ramda");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
var UnconnectedAppContainer = /*#__PURE__*/function (_React$Component) {
  _inherits(UnconnectedAppContainer, _React$Component);
  function UnconnectedAppContainer(props) {
    var _this;
    _classCallCheck(this, UnconnectedAppContainer);
    _this = _callSuper(this, UnconnectedAppContainer, [props]);
    if (props.hooks.layout_pre !== null || props.hooks.layout_post !== null || props.hooks.request_pre !== null || props.hooks.request_post !== null || props.hooks.callback_resolved !== null || props.hooks.request_refresh_jwt !== null) {
      var hooks = props.hooks;
      if (hooks.request_refresh_jwt) {
        hooks = _objectSpread(_objectSpread({}, hooks), {}, {
          request_refresh_jwt: (0, _ramda.memoizeWith)(_ramda.identity, hooks.request_refresh_jwt)
        });
      }
      props.dispatch((0, _index.setHooks)(hooks));
    }
    return _this;
  }
  _createClass(UnconnectedAppContainer, [{
    key: "UNSAFE_componentWillMount",
    value: function UNSAFE_componentWillMount() {
      var dispatch = this.props.dispatch;
      var config = (0, _config.default)();

      // preset common request params in the config
      config.fetch = {
        credentials: 'same-origin',
        headers: {
          Accept: 'application/json',
          'Content-Type': 'application/json'
        }
      };
      dispatch((0, _index.setConfig)(config));
    }
  }, {
    key: "render",
    value: function render() {
      var config = this.props.config;
      if ((0, _ramda.type)(config) === 'Null') {
        return /*#__PURE__*/_react.default.createElement("div", {
          className: "_dash-loading"
        }, "Loading...");
      }
      var show_undo_redo = config.show_undo_redo;
      return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, show_undo_redo ? /*#__PURE__*/_react.default.createElement(_Toolbar.default, null) : null, /*#__PURE__*/_react.default.createElement(_APIController.default, null), /*#__PURE__*/_react.default.createElement(_Loading.default, null), /*#__PURE__*/_react.default.createElement(_Reloader.default, null));
    }
  }]);
  return UnconnectedAppContainer;
}(_react.default.Component);
UnconnectedAppContainer.propTypes = {
  hooks: _propTypes.default.object,
  dispatch: _propTypes.default.func,
  config: _propTypes.default.object
};
var AppContainer = (0, _reactRedux.connect)(function (state) {
  return {
    history: state.history,
    config: state.config
  };
}, function (dispatch) {
  return {
    dispatch
  };
})(UnconnectedAppContainer);
var _default = exports.default = AppContainer;