"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CheckedComponent = CheckedComponent;
var _checkPropTypes = _interopRequireDefault(require("./checkPropTypes"));
var _exceptions = require("./exceptions");
var _createLibraryElement = require("./libraries/createLibraryElement");
var _propTypes = _interopRequireDefault(require("prop-types"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function CheckedComponent(p) {
  var element = p.element,
    extraProps = p.extraProps,
    props = p.props,
    children = p.children,
    type = p.type;
  var errorMessage = (0, _checkPropTypes.default)(element.propTypes, props, 'component prop', element);
  if (errorMessage) {
    (0, _exceptions.propTypeErrorHandler)(errorMessage, props, type);
  }
  return (0, _createLibraryElement.createLibraryElement)(element, props, extraProps, children);
}
CheckedComponent.propTypes = {
  children: _propTypes.default.any,
  element: _propTypes.default.any,
  layout: _propTypes.default.any,
  props: _propTypes.default.any,
  extraProps: _propTypes.default.any,
  id: _propTypes.default.string,
  type: _propTypes.default.string
};