"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _ramda = require("ramda");
var _reactRedux = require("react-redux");
var _actions = require("./actions");
var _isSimpleComponent = _interopRequireDefault(require("./isSimpleComponent"));
var _persistence = require("./persistence");
var _ComponentErrorBoundary = _interopRequireDefault(require("./components/error/ComponentErrorBoundary.react"));
var _dependencies = require("./actions/dependencies");
var _TreeContainer = require("./utils/TreeContainer");
var _APIController = require("./APIController.react");
var _LibraryComponent = _interopRequireDefault(require("./libraries/LibraryComponent"));
var _excluded = ["_dash_error"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
var NOT_LOADING = {
  is_loading: false
};
function isDryComponent(obj) {
  return (0, _ramda.type)(obj) === 'Object' && (0, _ramda.has)('type', obj) && (0, _ramda.has)('namespace', obj) && (0, _ramda.has)('props', obj);
}
var DashWrapper = function DashWrapper(props) {
  var context = (0, _react.useContext)(_APIController.DashContext);
  return /*#__PURE__*/_react.default.createElement(BaseTreeContainer, _extends({}, context.fn(), props, {
    _dashprivate_path: JSON.parse(props._dashprivate_path)
  }));
};
var TreeContainer = /*#__PURE__*/(0, _react.memo)(DashWrapper);
var BaseTreeContainer = /*#__PURE__*/function (_Component) {
  _inherits(BaseTreeContainer, _Component);
  function BaseTreeContainer(props) {
    var _this;
    _classCallCheck(this, BaseTreeContainer);
    _this = _callSuper(this, BaseTreeContainer, [props]);
    _this.setProps = _this.setProps.bind(_assertThisInitialized(_this));
    return _this;
  }
  _createClass(BaseTreeContainer, [{
    key: "createContainer",
    value: function createContainer(props, component, path) {
      var key = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : undefined;
      return (0, _isSimpleComponent.default)(component) ? component : /*#__PURE__*/_react.default.createElement(TreeContainer, {
        key: component && component.props && (0, _dependencies.stringifyId)(component.props.id) || key,
        _dashprivate_error: props._dashprivate_error,
        _dashprivate_layout: component,
        _dashprivate_loadingState: (0, _TreeContainer.getLoadingState)(component, path, props._dashprivate_loadingMap),
        _dashprivate_loadingStateHash: (0, _TreeContainer.getLoadingHash)(path, props._dashprivate_loadingMap),
        _dashprivate_path: JSON.stringify(path)
      });
    }
  }, {
    key: "setProps",
    value: function setProps(newProps) {
      var _this$props = this.props,
        _dashprivate_dispatch = _this$props._dashprivate_dispatch,
        _dashprivate_path = _this$props._dashprivate_path,
        _dashprivate_layout = _this$props._dashprivate_layout;
      var oldProps = this.getLayoutProps();
      var id = oldProps.id;
      var _dash_error = newProps._dash_error,
        rest = _objectWithoutProperties(newProps, _excluded);
      var changedProps = (0, _ramda.pickBy)(function (val, key) {
        return !(0, _ramda.equals)(val, oldProps[key]);
      }, rest);
      if (_dash_error) {
        _dashprivate_dispatch((0, _actions.onError)({
          type: 'frontEnd',
          error: _dash_error
        }));
      }
      if (!(0, _ramda.isEmpty)(changedProps)) {
        _dashprivate_dispatch(function (dispatch, getState) {
          var _getState = getState(),
            graphs = _getState.graphs;
          // Identify the modified props that are required for callbacks
          var watchedKeys = (0, _dependencies.getWatchedKeys)(id, (0, _ramda.keys)(changedProps), graphs);
          (0, _reactRedux.batch)(function () {
            // setProps here is triggered by the UI - record these changes
            // for persistence
            (0, _persistence.recordUiEdit)(_dashprivate_layout, newProps, dispatch);

            // Only dispatch changes to Dash if a watched prop changed
            if (watchedKeys.length) {
              dispatch((0, _actions.notifyObservers)({
                id,
                props: (0, _ramda.pick)(watchedKeys, changedProps)
              }));
            }

            // Always update this component's props
            dispatch((0, _actions.updateProps)({
              props: changedProps,
              itempath: _dashprivate_path
            }));
          });
        });
      }
    }
  }, {
    key: "getChildren",
    value: function getChildren(components, path) {
      var _this2 = this;
      if ((0, _ramda.isNil)(components)) {
        return null;
      }
      return Array.isArray(components) ? (0, _ramda.addIndex)(_ramda.map)(function (component, i) {
        return _this2.createContainer(_this2.props, component, (0, _ramda.concat)(path, ['props', 'children', i]));
      }, components) : this.createContainer(this.props, components, (0, _ramda.concat)(path, ['props', 'children']));
    }
  }, {
    key: "wrapChildrenProp",
    value: function wrapChildrenProp(node, childrenProp) {
      var _this3 = this;
      if (Array.isArray(node)) {
        return node.map(function (n, i) {
          return isDryComponent(n) ? _this3.createContainer(_this3.props, n, (0, _ramda.concat)(_this3.props._dashprivate_path, ['props'].concat(_toConsumableArray(childrenProp), [i])), i) : n;
        });
      }
      if (!isDryComponent(node)) {
        return node;
      }
      return this.createContainer(this.props, node, (0, _ramda.concat)(this.props._dashprivate_path, ['props'].concat(_toConsumableArray(childrenProp))));
    }
  }, {
    key: "getComponent",
    value: function getComponent(_dashprivate_layout, children, loading_state, setProps) {
      var _this4 = this;
      var _this$props2 = this.props,
        _dashprivate_config = _this$props2._dashprivate_config,
        _dashprivate_dispatch = _this$props2._dashprivate_dispatch,
        _dashprivate_error = _this$props2._dashprivate_error;
      if ((0, _ramda.isEmpty)(_dashprivate_layout)) {
        return null;
      }
      if ((0, _isSimpleComponent.default)(_dashprivate_layout)) {
        return _dashprivate_layout;
      }
      (0, _TreeContainer.validateComponent)(_dashprivate_layout);

      // Hydrate components props
      var childrenProps = (0, _ramda.pathOr)([], ['children_props', _dashprivate_layout.namespace, _dashprivate_layout.type], _dashprivate_config);
      var props = (0, _ramda.dissoc)('children', _dashprivate_layout.props);
      var _loop = function _loop() {
          var childrenProp = childrenProps[i];
          var handleObject = function handleObject(obj, opath) {
            return (0, _ramda.mapObjIndexed)(function (node, k) {
              return _this4.wrapChildrenProp(node, [].concat(_toConsumableArray(opath), [k]));
            }, obj);
          };
          if (childrenProp.includes('.')) {
            var path = childrenProp.split('.');
            var node;
            var nodeValue;
            if (childrenProp.includes('[]')) {
              var frontPath = [],
                backPath = [],
                found = false,
                hasObject = false;
              path.forEach(function (p) {
                if (!found) {
                  if (p.includes('[]')) {
                    found = true;
                    if (p.includes('{}')) {
                      hasObject = true;
                      frontPath.push(p.replace('{}', '').replace('[]', ''));
                    } else {
                      frontPath.push(p.replace('[]', ''));
                    }
                  } else if (p.includes('{}')) {
                    hasObject = true;
                    frontPath.push(p.replace('{}', ''));
                  } else {
                    frontPath.push(p);
                  }
                } else {
                  if (p.includes('{}')) {
                    hasObject = true;
                    backPath.push(p.replace('{}', ''));
                  } else {
                    backPath.push(p);
                  }
                }
              });
              node = (0, _ramda.path)(frontPath, props);
              if (node === undefined || !node.length) {
                return 0; // continue
              }
              var firstNode = (0, _ramda.path)(backPath, node[0]);
              if (!firstNode) {
                return 0; // continue
              }
              nodeValue = node.map(function (element, i) {
                var elementPath = (0, _ramda.concat)(frontPath, (0, _ramda.concat)([i], backPath));
                var listValue;
                if (hasObject) {
                  if (backPath.length) {
                    listValue = handleObject((0, _ramda.path)(backPath, element), elementPath);
                  } else {
                    listValue = handleObject(element, elementPath);
                  }
                } else {
                  listValue = _this4.wrapChildrenProp((0, _ramda.path)(backPath, element), elementPath);
                }
                return (0, _ramda.assocPath)(backPath, listValue, element);
              });
              path = frontPath;
            } else {
              if (childrenProp.includes('{}')) {
                // Only supports one level of nesting.
                var front = [];
                var dynamic = [];
                var hasBack = false;
                var _backPath = [];
                for (var j = 0; j < path.length; j++) {
                  var cur = path[j];
                  if (cur.includes('{}')) {
                    dynamic = (0, _ramda.concat)(front, [cur.replace('{}', '')]);
                    if (j < path.length - 1) {
                      hasBack = true;
                    }
                  } else {
                    if (hasBack) {
                      _backPath.push(cur);
                    } else {
                      front.push(cur);
                    }
                  }
                }
                var dynValue = (0, _ramda.path)(dynamic, props);
                if (dynValue !== undefined) {
                  nodeValue = (0, _ramda.mapObjIndexed)(function (d, k) {
                    return _this4.wrapChildrenProp(hasBack ? (0, _ramda.path)(_backPath, d) : d, hasBack ? (0, _ramda.concat)(dynamic, (0, _ramda.concat)([k], _backPath)) : (0, _ramda.concat)(dynamic, [k]));
                  }, dynValue);
                  path = dynamic;
                }
              } else {
                node = (0, _ramda.path)(path, props);
                if (node === undefined) {
                  return 0; // continue
                }
                nodeValue = _this4.wrapChildrenProp(node, path);
              }
            }
            props = (0, _ramda.assocPath)(path, nodeValue, props);
          } else {
            if (childrenProp.includes('{}')) {
              var opath = childrenProp.replace('{}', '');
              var isArray = childrenProp.includes('[]');
              if (isArray) {
                opath = opath.replace('[]', '');
              }
              var _node = props[opath];
              if (_node !== undefined) {
                if (isArray) {
                  for (var _j = 0; _j < _node.length; _j++) {
                    var aPath = (0, _ramda.concat)([opath], [_j]);
                    props = (0, _ramda.assocPath)(aPath, handleObject(_node[_j], aPath), props);
                  }
                } else {
                  props = (0, _ramda.assoc)(opath, handleObject(_node, [opath]), props);
                }
              }
            } else {
              var _node2 = props[childrenProp];
              if (_node2 !== undefined) {
                props = (0, _ramda.assoc)(childrenProp, _this4.wrapChildrenProp(_node2, [childrenProp]), props);
              }
            }
          }
        },
        _ret;
      for (var i = 0; i < childrenProps.length; i++) {
        _ret = _loop();
        if (_ret === 0) continue;
      }
      if ((0, _ramda.type)(props.id) === 'Object') {
        // Turn object ids (for wildcards) into unique strings.
        // Because of the `dissoc` above we're not mutating the layout,
        // just the id we pass on to the rendered component
        props.id = (0, _dependencies.stringifyId)(props.id);
      }
      var extraProps = {
        loading_state: loading_state || NOT_LOADING,
        setProps
      };
      return /*#__PURE__*/_react.default.createElement(_ComponentErrorBoundary.default, {
        componentType: _dashprivate_layout.type,
        componentId: props.id,
        key: props.id,
        dispatch: _dashprivate_dispatch,
        error: _dashprivate_error
      }, /*#__PURE__*/_react.default.createElement(_LibraryComponent.default, {
        children: children,
        type: _dashprivate_layout.type,
        namespace: _dashprivate_layout.namespace,
        props: props,
        extraProps: extraProps,
        props_check: _dashprivate_config.props_check
      }));
    }
  }, {
    key: "getLayoutProps",
    value: function getLayoutProps() {
      return (0, _ramda.propOr)({}, 'props', this.props._dashprivate_layout);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
        _dashprivate_layout = _this$props3._dashprivate_layout,
        _dashprivate_loadingState = _this$props3._dashprivate_loadingState,
        _dashprivate_path = _this$props3._dashprivate_path;
      var layoutProps = this.getLayoutProps();
      var children = this.getChildren(layoutProps.children, _dashprivate_path);
      return this.getComponent(_dashprivate_layout, children, _dashprivate_loadingState, this.setProps);
    }
  }]);
  return BaseTreeContainer;
}(_react.Component);
TreeContainer.propTypes = {
  _dashprivate_error: _propTypes.default.any,
  _dashprivate_layout: _propTypes.default.object,
  _dashprivate_loadingState: _propTypes.default.oneOfType([_propTypes.default.object, _propTypes.default.bool]),
  _dashprivate_loadingStateHash: _propTypes.default.string,
  _dashprivate_path: _propTypes.default.string
};
BaseTreeContainer.propTypes = _objectSpread(_objectSpread({}, TreeContainer.propTypes), {}, {
  _dashprivate_config: _propTypes.default.object,
  _dashprivate_dispatch: _propTypes.default.func,
  _dashprivate_graphs: _propTypes.default.any,
  _dashprivate_loadingMap: _propTypes.default.any,
  _dashprivate_path: _propTypes.default.array
});
var _default = exports.default = TreeContainer;