"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.aggregateCallbacks = exports.addWatchedCallbacks = exports.addStoredCallbacks = exports.addRequestedCallbacks = exports.addPrioritizedCallbacks = exports.addExecutingCallbacks = exports.addExecutedCallbacks = exports.addCompletedCallbacks = exports.addBlockedCallbacks = void 0;
exports.executeCallback = executeCallback;
exports.removeWatchedCallbacks = exports.removeStoredCallbacks = exports.removeRequestedCallbacks = exports.removePrioritizedCallbacks = exports.removeExecutingCallbacks = exports.removeExecutedCallbacks = exports.removeBlockedCallbacks = void 0;
var _ramda = require("ramda");
var _constants = require("../constants/constants");
var _constants2 = require("./constants");
var _callbacks = require("../reducers/callbacks");
var _dependencies = require("./dependencies");
var _utils = require("./utils");
var _2 = require(".");
var _reduxActions = require("redux-actions");
var _actions = require("../actions");
var _index = require("./index");
var _patch = require("./patch");
var _paths = require("./paths");
var _requestDependencies = require("./requestDependencies");
var _loadLibrary = _interopRequireDefault(require("../libraries/loadLibrary"));
var _fetchDist = _interopRequireDefault(require("../libraries/fetchDist"));
var _libraries = require("./libraries");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ _regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == typeof h && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw new Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator.return && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(typeof e + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw new Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, catch: function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw new Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
var addBlockedCallbacks = exports.addBlockedCallbacks = (0, _reduxActions.createAction)(_callbacks.CallbackActionType.AddBlocked);
var addCompletedCallbacks = exports.addCompletedCallbacks = (0, _reduxActions.createAction)(_callbacks.CallbackAggregateActionType.AddCompleted);
var addExecutedCallbacks = exports.addExecutedCallbacks = (0, _reduxActions.createAction)(_callbacks.CallbackActionType.AddExecuted);
var addExecutingCallbacks = exports.addExecutingCallbacks = (0, _reduxActions.createAction)(_callbacks.CallbackActionType.AddExecuting);
var addPrioritizedCallbacks = exports.addPrioritizedCallbacks = (0, _reduxActions.createAction)(_callbacks.CallbackActionType.AddPrioritized);
var addRequestedCallbacks = exports.addRequestedCallbacks = (0, _reduxActions.createAction)(_callbacks.CallbackActionType.AddRequested);
var addStoredCallbacks = exports.addStoredCallbacks = (0, _reduxActions.createAction)(_callbacks.CallbackActionType.AddStored);
var addWatchedCallbacks = exports.addWatchedCallbacks = (0, _reduxActions.createAction)(_callbacks.CallbackActionType.AddWatched);
var removeExecutedCallbacks = exports.removeExecutedCallbacks = (0, _reduxActions.createAction)(_callbacks.CallbackActionType.RemoveExecuted);
var removeBlockedCallbacks = exports.removeBlockedCallbacks = (0, _reduxActions.createAction)(_callbacks.CallbackActionType.RemoveBlocked);
var removeExecutingCallbacks = exports.removeExecutingCallbacks = (0, _reduxActions.createAction)(_callbacks.CallbackActionType.RemoveExecuting);
var removePrioritizedCallbacks = exports.removePrioritizedCallbacks = (0, _reduxActions.createAction)(_callbacks.CallbackActionType.RemovePrioritized);
var removeRequestedCallbacks = exports.removeRequestedCallbacks = (0, _reduxActions.createAction)(_callbacks.CallbackActionType.RemoveRequested);
var removeStoredCallbacks = exports.removeStoredCallbacks = (0, _reduxActions.createAction)(_callbacks.CallbackActionType.RemoveStored);
var removeWatchedCallbacks = exports.removeWatchedCallbacks = (0, _reduxActions.createAction)(_callbacks.CallbackActionType.RemoveWatched);
var aggregateCallbacks = exports.aggregateCallbacks = (0, _reduxActions.createAction)(_callbacks.CallbackAggregateActionType.Aggregate);
var updateResourceUsage = (0, _reduxActions.createAction)('UPDATE_RESOURCE_USAGE');
var addCallbackJob = (0, _reduxActions.createAction)('ADD_CALLBACK_JOB');
var removeCallbackJob = (0, _reduxActions.createAction)('REMOVE_CALLBACK_JOB');
var setCallbackJobOutdated = (0, _reduxActions.createAction)('CALLBACK_JOB_OUTDATED');
function unwrapIfNotMulti(paths, idProps, spec, anyVals, depType) {
  var msg = '';
  if ((0, _dependencies.isMultiValued)(spec)) {
    return [idProps, msg];
  }
  if (idProps.length !== 1) {
    if (!idProps.length) {
      var isStr = typeof spec.id === 'string';
      msg = 'A nonexistent object was used in an `' + depType + '` of a Dash callback. The id of this object is ' + (isStr ? '`' + spec.id + '`' : JSON.stringify(spec.id) + (anyVals ? ' with MATCH values ' + anyVals : '')) + ' and the property is `' + spec.property + (isStr ? '`. The string ids in the current layout are: [' + (0, _ramda.keys)(paths.strs).join(', ') + ']' : '`. The wildcard ids currently available are logged above.');
    } else {
      msg = 'Multiple objects were found for an `' + depType + '` of a callback that only takes one value. The id spec is ' + JSON.stringify(spec.id) + (anyVals ? ' with MATCH values ' + anyVals : '') + ' and the property is `' + spec.property + '`. The objects we found are: ' + JSON.stringify((0, _ramda.map)((0, _ramda.pick)(['id', 'property']), idProps));
    }
  }
  return [idProps[0], msg];
}
function fillVals(paths, layout, cb, specs, depType) {
  var allowAllMissing = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : false;
  var getter = depType === 'Input' ? cb.getInputs : cb.getState;
  var errors = [];
  var emptyMultiValues = 0;
  var inputVals = getter(paths).map(function (inputList, i) {
    var _unwrapIfNotMulti = unwrapIfNotMulti(paths, inputList.map(function (_ref) {
        var id = _ref.id,
          property = _ref.property,
          path_ = _ref.path;
        return {
          id,
          property,
          value: (0, _ramda.path)([].concat(_toConsumableArray(path_), ['props', property]), layout)
        };
      }), specs[i], cb.anyVals, depType),
      _unwrapIfNotMulti2 = _slicedToArray(_unwrapIfNotMulti, 2),
      inputs = _unwrapIfNotMulti2[0],
      inputError = _unwrapIfNotMulti2[1];
    if ((0, _dependencies.isMultiValued)(specs[i]) && !inputs.length) {
      emptyMultiValues++;
    }
    if (inputError) {
      errors.push(inputError);
    }
    return inputs;
  });
  if (errors.length) {
    if (allowAllMissing && errors.length + emptyMultiValues === inputVals.length) {
      // We have at least one non-multivalued input, but all simple and
      // multi-valued inputs are missing.
      // (if all inputs are multivalued and all missing we still return
      // them as normal, and fire the callback.)
      return null;
    }
    // If we get here we have some missing and some present inputs.
    // Or all missing in a context that doesn't allow this.
    // That's a real problem, so throw the first message as an error.
    refErr(errors, paths);
  }
  return inputVals;
}
function refErr(errors, paths) {
  var err = errors[0];
  if (err.indexOf('logged above') !== -1) {
    // Wildcard reference errors mention a list of wildcard specs logged
    // TODO: unwrapped list of wildcard ids?
    // eslint-disable-next-line no-console
    console.error(paths.objs);
  }
  throw new ReferenceError(err);
}
var getVals = function getVals(input) {
  return Array.isArray(input) ? (0, _ramda.pluck)('value', input) : input.value;
};
var zipIfArray = function zipIfArray(a, b) {
  return Array.isArray(a) ? (0, _ramda.zip)(a, b) : [[a, b]];
};
function cleanOutputProp(property) {
  return property.split('@')[0];
}
function handleClientside(_x, _x2, _x3, _x4) {
  return _handleClientside.apply(this, arguments);
}
function _handleClientside() {
  _handleClientside = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(dispatch, clientside_function, config, payload) {
    var dc, inputs, outputs, state, requestTime, inputDict, stateDict, result, status, _dc$namespace, _returnValue, namespace, function_name, args, returnValue, totalTime, resources;
    return _regeneratorRuntime().wrap(function _callee2$(_context3) {
      while (1) switch (_context3.prev = _context3.next) {
        case 0:
          dc = window.dash_clientside = window.dash_clientside || {};
          if (!dc.no_update) {
            Object.defineProperty(dc, 'no_update', {
              value: {
                description: 'Return to prevent updating an Output.'
              },
              writable: false
            });
            Object.defineProperty(dc, 'PreventUpdate', {
              value: {
                description: 'Throw to prevent updating all Outputs.'
              },
              writable: false
            });
          }
          inputs = payload.inputs, outputs = payload.outputs, state = payload.state;
          requestTime = Date.now();
          inputDict = inputsToDict(inputs);
          stateDict = inputsToDict(state);
          result = {};
          status = _constants.STATUS.OK;
          _context3.prev = 8;
          namespace = clientside_function.namespace, function_name = clientside_function.function_name;
          args = inputs.map(getVals);
          if (state) {
            args = (0, _ramda.concat)(args, state.map(getVals));
          }

          // setup callback context
          dc.callback_context = {};
          dc.callback_context.triggered = payload.changedPropIds.map(function (prop_id) {
            return {
              prop_id: prop_id,
              value: inputDict[prop_id]
            };
          });
          dc.callback_context.triggered_id = getTriggeredId(payload.changedPropIds);
          dc.callback_context.inputs_list = inputs;
          dc.callback_context.inputs = inputDict;
          dc.callback_context.states_list = state;
          dc.callback_context.states = stateDict;
          returnValue = (_dc$namespace = dc[namespace])[function_name].apply(_dc$namespace, _toConsumableArray(args));
          delete dc.callback_context;
          if (!(typeof ((_returnValue = returnValue) === null || _returnValue === void 0 ? void 0 : _returnValue.then) === 'function')) {
            _context3.next = 25;
            break;
          }
          _context3.next = 24;
          return returnValue;
        case 24:
          returnValue = _context3.sent;
        case 25:
          zipIfArray(outputs, returnValue).forEach(function (_ref10) {
            var _ref11 = _slicedToArray(_ref10, 2),
              outi = _ref11[0],
              reti = _ref11[1];
            zipIfArray(outi, reti).forEach(function (_ref12) {
              var _ref13 = _slicedToArray(_ref12, 2),
                outij = _ref13[0],
                retij = _ref13[1];
              var id = outij.id,
                property = outij.property;
              var idStr = (0, _dependencies.stringifyId)(id);
              var dataForId = result[idStr] = result[idStr] || {};
              if (retij !== dc.no_update) {
                dataForId[cleanOutputProp(property)] = retij;
              }
            });
          });
          _context3.next = 36;
          break;
        case 28:
          _context3.prev = 28;
          _context3.t0 = _context3["catch"](8);
          if (!(_context3.t0 === dc.PreventUpdate)) {
            _context3.next = 34;
            break;
          }
          status = _constants.STATUS.PREVENT_UPDATE;
          _context3.next = 36;
          break;
        case 34:
          status = _constants.STATUS.CLIENTSIDE_ERROR;
          throw _context3.t0;
        case 36:
          _context3.prev = 36;
          delete dc.callback_context;

          // Setting server = client forces network = 0
          totalTime = Date.now() - requestTime;
          resources = {
            __dash_server: totalTime,
            __dash_client: totalTime,
            __dash_upload: 0,
            __dash_download: 0
          };
          if (config.ui) {
            dispatch(updateResourceUsage({
              id: payload.output,
              usage: resources,
              status,
              result,
              inputs,
              state
            }));
          }
          return _context3.finish(36);
        case 42:
          return _context3.abrupt("return", result);
        case 43:
        case "end":
          return _context3.stop();
      }
    }, _callee2, null, [[8, 28, 36, 42]]);
  }));
  return _handleClientside.apply(this, arguments);
}
function sideUpdate(outputs, dispatch, paths) {
  (0, _ramda.toPairs)(outputs).forEach(function (_ref2) {
    var _ref3 = _slicedToArray(_ref2, 2),
      id = _ref3[0],
      value = _ref3[1];
    var _id$split = id.split('.'),
      _id$split2 = _slicedToArray(_id$split, 2),
      componentId = _id$split2[0],
      propName = _id$split2[1];
    var componentPath = paths.strs[componentId];
    dispatch((0, _index.updateProps)({
      props: {
        [propName]: value
      },
      itempath: componentPath
    }));
    dispatch((0, _index.notifyObservers)({
      id: componentId,
      props: {
        [propName]: value
      }
    }));
  });
}
function handleServerside(dispatch, hooks, config, payload, paths, long, additionalArgs, getState, output, running) {
  if (hooks.request_pre) {
    hooks.request_pre(payload);
  }
  var requestTime = Date.now();
  var body = JSON.stringify(payload);
  var cacheKey;
  var job;
  var runningOff;
  var progressDefault;
  var moreArgs = additionalArgs;
  var libraries = Object.keys(getState().libraries);
  if (running) {
    sideUpdate(running.running, dispatch, paths);
    runningOff = running.runningOff;
  }
  var fetchCallback = function fetchCallback() {
    var headers = (0, _2.getCSRFHeader)();
    var url = "".concat((0, _utils.urlBase)(config), "_dash-update-component");
    var addArg = function addArg(name, value) {
      var delim = '?';
      if (url.includes('?')) {
        delim = '&';
      }
      url = "".concat(url).concat(delim).concat(name, "=").concat(value);
    };
    if (cacheKey) {
      addArg('cacheKey', cacheKey);
    }
    if (job) {
      addArg('job', job);
    }
    if (moreArgs) {
      moreArgs.forEach(function (_ref4) {
        var _ref5 = _slicedToArray(_ref4, 2),
          key = _ref5[0],
          value = _ref5[1];
        return addArg(key, value);
      });
      moreArgs = moreArgs.filter(function (_ref6) {
        var _ref7 = _slicedToArray(_ref6, 3),
          _ = _ref7[0],
          __ = _ref7[1],
          single = _ref7[2];
        return !single;
      });
    }
    return fetch(url, (0, _ramda.mergeDeepRight)(config.fetch, {
      method: 'POST',
      headers,
      body
    }));
  };
  return new Promise(function (resolve, reject) {
    var handleOutput = function handleOutput(res) {
      var status = res.status;
      if (job) {
        var callbackJob = getState().callbackJobs[job];
        if (callbackJob !== null && callbackJob !== void 0 && callbackJob.outdated) {
          dispatch(removeCallbackJob({
            jobId: job
          }));
          return resolve({});
        }
      }
      function recordProfile(result) {
        if (config.ui) {
          // Callback profiling - only relevant if we're showing the debug ui
          var resources = {
            __dash_server: 0,
            __dash_client: Date.now() - requestTime,
            __dash_upload: body.length,
            __dash_download: Number(res.headers.get('Content-Length'))
          };
          var timingHeaders = res.headers.get('Server-Timing') || '';
          timingHeaders.split(',').forEach(function (header) {
            var name = header.split(';')[0];
            var dur = header.match(/;dur=[0-9.]+/);
            if (dur) {
              resources[name] = Number(dur[0].slice(5));
            }
          });
          dispatch(updateResourceUsage({
            id: payload.output,
            usage: resources,
            status,
            result,
            inputs: payload.inputs,
            state: payload.state
          }));
        }
      }
      var finishLine = function finishLine(data) {
        var multi = data.multi,
          response = data.response;
        if (hooks.request_post) {
          hooks.request_post(payload, response);
        }
        var result;
        if (multi) {
          result = response;
        } else {
          var _output = payload.output;
          var id = _output.substr(0, _output.lastIndexOf('.'));
          result = {
            [id]: response.props
          };
        }
        recordProfile(result);
        resolve(result);
      };
      var completeJob = function completeJob() {
        if (job) {
          dispatch(removeCallbackJob({
            jobId: job
          }));
        }
        if (runningOff) {
          sideUpdate(runningOff, dispatch, paths);
        }
        if (progressDefault) {
          sideUpdate(progressDefault, dispatch, paths);
        }
      };
      if (status === _constants.STATUS.OK) {
        res.json().then(function (data) {
          if (!cacheKey && data.cacheKey) {
            cacheKey = data.cacheKey;
          }
          if (!job && data.job) {
            var jobInfo = {
              jobId: data.job,
              cacheKey: data.cacheKey,
              cancelInputs: data.cancel,
              progressDefault: data.progressDefault,
              output
            };
            dispatch(addCallbackJob(jobInfo));
            job = data.job;
          }
          if (data.progress) {
            sideUpdate(data.progress, dispatch, paths);
          }
          if (!progressDefault && data.progressDefault) {
            progressDefault = data.progressDefault;
          }
          if (!long || data.response !== undefined) {
            var newLibs = [];
            Object.values(data.response).forEach(function (newData) {
              Object.values(newData).forEach(function (newProp) {
                (0, _utils.crawlLayout)(newProp, function (c) {
                  if (c.namespace && !libraries.includes(c.namespace) && !newLibs.includes(c.namespace)) {
                    newLibs.push(c.namespace);
                  }
                });
              });
            });
            if (newLibs.length) {
              (0, _fetchDist.default)(getState().config.requests_pathname_prefix, newLibs).then(function (data) {
                return Promise.all(data.map(_loadLibrary.default));
              }).then(function () {
                completeJob();
                finishLine(data);
                dispatch((0, _libraries.setLibraryLoaded)({
                  libraries: newLibs
                }));
              });
            } else {
              completeJob();
              finishLine(data);
            }
          } else {
            // Poll chain.
            setTimeout(handle, long.interval !== undefined ? long.interval : 500);
          }
        });
      } else if (status === _constants.STATUS.PREVENT_UPDATE) {
        completeJob();
        recordProfile({});
        resolve({});
      } else {
        completeJob();
        reject(res);
      }
    };
    var handleError = function handleError() {
      if (config.ui) {
        dispatch(updateResourceUsage({
          id: payload.output,
          status: _constants.STATUS.NO_RESPONSE,
          result: {},
          inputs: payload.inputs,
          state: payload.state
        }));
      }
      reject(new Error('Callback failed: the server did not respond.'));
    };
    var handle = function handle() {
      fetchCallback().then(handleOutput, handleError);
    };
    handle();
  });
}
function inputsToDict(inputs_list) {
  // Ported directly from _utils.py, inputs_to_dict
  // takes an array of inputs (some inputs may be an array)
  // returns an Object (map):
  //  keys of the form `id.property` or `{"id": 0}.property`
  //  values contain the property value
  if (!inputs_list) {
    return {};
  }
  var inputs = {};
  for (var i = 0; i < inputs_list.length; i++) {
    if (Array.isArray(inputs_list[i])) {
      var inputsi = inputs_list[i];
      for (var ii = 0; ii < inputsi.length; ii++) {
        var _inputsi$ii$value;
        var id_str = "".concat((0, _dependencies.stringifyId)(inputsi[ii].id), ".").concat(inputsi[ii].property);
        inputs[id_str] = (_inputsi$ii$value = inputsi[ii].value) !== null && _inputsi$ii$value !== void 0 ? _inputsi$ii$value : null;
      }
    } else {
      var _inputs_list$i$value;
      var _id_str = "".concat((0, _dependencies.stringifyId)(inputs_list[i].id), ".").concat(inputs_list[i].property);
      inputs[_id_str] = (_inputs_list$i$value = inputs_list[i].value) !== null && _inputs_list$i$value !== void 0 ? _inputs_list$i$value : null;
    }
  }
  return inputs;
}
function getTriggeredId(triggered) {
  // for regular callbacks,  takes the first triggered prop_id, e.g.  "btn.n_clicks" and returns "btn"
  // for pattern matching callback, e.g. '{"index":0, "type":"btn"}' and returns {index:0, type: "btn"}'
  if (triggered && triggered.length) {
    var componentId = triggered[0].split('.')[0];
    if (componentId.startsWith('{')) {
      componentId = JSON.parse(componentId);
    }
    return componentId;
  }
}
function executeCallback(cb, config, hooks, paths, layout, _ref8, dispatch, getState) {
  var allOutputs = _ref8.allOutputs;
  var _cb$callback = cb.callback,
    output = _cb$callback.output,
    inputs = _cb$callback.inputs,
    state = _cb$callback.state,
    clientside_function = _cb$callback.clientside_function,
    long = _cb$callback.long,
    dynamic_creator = _cb$callback.dynamic_creator;
  try {
    var inVals = fillVals(paths, layout, cb, inputs, 'Input', true);

    /* Prevent callback if there's no inputs */
    if (inVals === null) {
      return _objectSpread(_objectSpread({}, cb), {}, {
        executionPromise: null
      });
    }
    var outputs = [];
    var outputErrors = [];
    allOutputs.forEach(function (out, i) {
      var _unwrapIfNotMulti3 = unwrapIfNotMulti(paths, (0, _ramda.map)((0, _ramda.pick)(['id', 'property']), out), cb.callback.outputs[i], cb.anyVals, 'Output'),
        _unwrapIfNotMulti4 = _slicedToArray(_unwrapIfNotMulti3, 2),
        outi = _unwrapIfNotMulti4[0],
        erri = _unwrapIfNotMulti4[1];
      outputs.push(outi);
      if (erri) {
        outputErrors.push(erri);
      }
    });
    if (outputErrors.length) {
      if ((0, _ramda.flatten)(inVals).length) {
        refErr(outputErrors, paths);
      }
      // This case is all-empty multivalued wildcard inputs,
      // which we would normally fire the callback for, except
      // some outputs are missing. So instead we treat it like
      // regular missing inputs and just silently prevent it.
      return _objectSpread(_objectSpread({}, cb), {}, {
        executionPromise: null
      });
    }
    var __execute = /*#__PURE__*/function () {
      var _ref9 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
        var payload, data, newConfig, newHeaders, lastError, additionalArgs, _loop, _ret, retry;
        return _regeneratorRuntime().wrap(function _callee$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              _context2.prev = 0;
              payload = {
                output,
                outputs: (0, _dependencies.isMultiOutputProp)(output) ? outputs : outputs[0],
                inputs: inVals,
                changedPropIds: (0, _ramda.keys)(cb.changedPropIds),
                state: cb.callback.state.length ? fillVals(paths, layout, cb, state, 'State') : undefined
              };
              if (!clientside_function) {
                _context2.next = 13;
                break;
              }
              _context2.prev = 3;
              _context2.next = 6;
              return handleClientside(dispatch, clientside_function, config, payload);
            case 6:
              data = _context2.sent;
              return _context2.abrupt("return", {
                data,
                payload
              });
            case 10:
              _context2.prev = 10;
              _context2.t0 = _context2["catch"](3);
              return _context2.abrupt("return", {
                error: _context2.t0,
                payload
              });
            case 13:
              newConfig = config;
              newHeaders = null;
              additionalArgs = [];
              (0, _ramda.values)(getState().callbackJobs).forEach(function (job) {
                if (cb.callback.output === job.output) {
                  // Terminate the old jobs that are not completed
                  // set as outdated for the callback promise to
                  // resolve and remove after.
                  additionalArgs.push(['oldJob', job.jobId, true]);
                  dispatch(setCallbackJobOutdated({
                    jobId: job.jobId
                  }));
                }
                if (!job.cancelInputs) {
                  return;
                }
                var inter = (0, _ramda.intersection)(job.cancelInputs, cb.callback.inputs);
                if (inter.length) {
                  additionalArgs.push(['cancelJob', job.jobId]);
                  if (job.progressDefault) {
                    sideUpdate(job.progressDefault, dispatch, paths);
                  }
                }
              });
              _loop = /*#__PURE__*/_regeneratorRuntime().mark(function _loop() {
                var _data, currentLayout, body, oldJwt, newJwt;
                return _regeneratorRuntime().wrap(function _loop$(_context) {
                  while (1) switch (_context.prev = _context.next) {
                    case 0:
                      _context.prev = 0;
                      _context.next = 3;
                      return handleServerside(dispatch, hooks, newConfig, payload, paths, long, additionalArgs.length ? additionalArgs : undefined, getState, cb.callback.output, cb.callback.running);
                    case 3:
                      _data = _context.sent;
                      if (newHeaders) {
                        dispatch((0, _actions.addHttpHeaders)(newHeaders));
                      }
                      // Layout may have changed.
                      currentLayout = getState().layout;
                      (0, _ramda.flatten)(outputs).forEach(function (out) {
                        var propName = cleanOutputProp(out.property);
                        var outputPath = (0, _paths.getPath)(paths, out.id);
                        var previousValue = (0, _ramda.path)(outputPath.concat(['props', propName]), currentLayout);
                        var dataPath = [(0, _dependencies.stringifyId)(out.id), propName];
                        var outputValue = (0, _ramda.path)(dataPath, _data);
                        if ((0, _patch.isPatch)(outputValue)) {
                          if (previousValue === undefined) {
                            throw new Error('Cannot patch undefined');
                          }
                          _data = (0, _ramda.assocPath)(dataPath, (0, _patch.handlePatch)(previousValue, outputValue), _data);
                        }
                      });
                      if (dynamic_creator) {
                        setTimeout(function () {
                          return dispatch((0, _requestDependencies.requestDependencies)());
                        }, 0);
                      }
                      return _context.abrupt("return", {
                        v: {
                          data: _data,
                          payload
                        }
                      });
                    case 11:
                      _context.prev = 11;
                      _context.t0 = _context["catch"](0);
                      lastError = _context.t0;
                      if (!(retry <= _constants2.MAX_AUTH_RETRIES && (_context.t0.status === _constants.STATUS.UNAUTHORIZED || _context.t0.status === _constants.STATUS.BAD_REQUEST))) {
                        _context.next = 29;
                        break;
                      }
                      _context.next = 17;
                      return _context.t0.text();
                    case 17:
                      body = _context.sent;
                      if (!body.includes(_constants.JWT_EXPIRED_MESSAGE)) {
                        _context.next = 29;
                        break;
                      }
                      if (!(hooks.request_refresh_jwt !== null)) {
                        _context.next = 29;
                        break;
                      }
                      oldJwt = null;
                      if (config.fetch.headers.Authorization) {
                        oldJwt = config.fetch.headers.Authorization.substr('Bearer '.length);
                      }
                      _context.next = 24;
                      return hooks.request_refresh_jwt(oldJwt);
                    case 24:
                      newJwt = _context.sent;
                      if (!newJwt) {
                        _context.next = 29;
                        break;
                      }
                      newHeaders = {
                        Authorization: "Bearer ".concat(newJwt)
                      };
                      newConfig = (0, _ramda.mergeDeepRight)(config, {
                        fetch: {
                          headers: newHeaders
                        }
                      });
                      return _context.abrupt("return", 0);
                    case 29:
                      return _context.abrupt("return", 1);
                    case 30:
                    case "end":
                      return _context.stop();
                  }
                }, _loop, null, [[0, 11]]);
              });
              retry = 0;
            case 19:
              if (!(retry <= _constants2.MAX_AUTH_RETRIES)) {
                _context2.next = 31;
                break;
              }
              return _context2.delegateYield(_loop(), "t1", 21);
            case 21:
              _ret = _context2.t1;
              if (!(_ret === 0)) {
                _context2.next = 24;
                break;
              }
              return _context2.abrupt("continue", 28);
            case 24:
              if (!(_ret === 1)) {
                _context2.next = 26;
                break;
              }
              return _context2.abrupt("break", 31);
            case 26:
              if (!_ret) {
                _context2.next = 28;
                break;
              }
              return _context2.abrupt("return", _ret.v);
            case 28:
              retry++;
              _context2.next = 19;
              break;
            case 31:
              return _context2.abrupt("return", {
                error: lastError,
                payload: null
              });
            case 34:
              _context2.prev = 34;
              _context2.t2 = _context2["catch"](0);
              return _context2.abrupt("return", {
                error: _context2.t2,
                payload: null
              });
            case 37:
            case "end":
              return _context2.stop();
          }
        }, _callee, null, [[0, 34], [3, 10]]);
      }));
      return function __execute() {
        return _ref9.apply(this, arguments);
      };
    }();
    var newCb = _objectSpread(_objectSpread({}, cb), {}, {
      executionPromise: __execute()
    });
    return newCb;
  } catch (error) {
    return _objectSpread(_objectSpread({}, cb), {}, {
      executionPromise: {
        error,
        payload: null
      }
    });
  }
}