"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _librariesContext = require("./librariesContext");
var _registry = _interopRequireDefault(require("../registry"));
var _CheckedComponent = require("../CheckedComponent.react");
var _createLibraryElement = require("./createLibraryElement");
var _excluded = ["props_check", "namespace", "type"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
var LibraryComponent = function LibraryComponent(props) {
  var props_check = props.props_check,
    namespace = props.namespace,
    type = props.type,
    rest = _objectWithoutProperties(props, _excluded);
  var context = (0, _react.useContext)(_librariesContext.LibrariesContext);
  (0, _react.useEffect)(function () {
    context.addToLoad(namespace);
  }, []);
  if (!context.isLoaded(namespace)) {
    return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null);
  }
  var element = _registry.default.resolve({
    namespace,
    type
  });
  if (props_check) {
    return /*#__PURE__*/_react.default.createElement(_CheckedComponent.CheckedComponent, {
      children: rest.children,
      element: element,
      props: rest.props,
      extraProps: rest.extraProps,
      type: type
    });
  }
  return (0, _createLibraryElement.createLibraryElement)(element, rest.props, rest.extraProps, rest.children);
};
var _default = exports.default = LibraryComponent;