"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _librariesContext = require("./librariesContext");
var _utils = require("../actions/utils");
var _ramda = require("ramda");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
var LibraryProvider = function LibraryProvider(props) {
  var children = props.children,
    requests_pathname_prefix = props.requests_pathname_prefix,
    onReady = props.onReady,
    ready = props.ready,
    initialLibraries = props.initialLibraries;
  var contextValue = (0, _librariesContext.createLibrariesContext)(requests_pathname_prefix, initialLibraries, onReady, ready);
  return /*#__PURE__*/_react.default.createElement(_librariesContext.LibrariesContext.Provider, {
    value: contextValue
  }, children);
};
var LibraryManager = function LibraryManager(props) {
  var children = props.children,
    ready = props.ready,
    layout = props.layout;
  var _useState = (0, _react.useState)(null),
    _useState2 = _slicedToArray(_useState, 2),
    initialLibraries = _useState2[0],
    setInitialLibraries = _useState2[1];
  (0, _react.useEffect)(function () {
    if (layout && !(0, _ramda.isEmpty)(layout) && !ready && !initialLibraries) {
      var libraries = [];
      (0, _utils.crawlLayout)(layout, function (child) {
        if (child.namespace && !libraries.includes(child.namespace)) {
          libraries.push(child.namespace);
        }
      });
      setInitialLibraries(libraries);
    }
  }, [layout, ready, initialLibraries]);
  if (!initialLibraries) {
    return children;
  }
  return /*#__PURE__*/_react.default.createElement(LibraryProvider, _extends({}, props, {
    initialLibraries: initialLibraries
  }), children);
};
var _default = exports.default = LibraryManager;