"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = librariesReducer;
var _ramda = require("ramda");
var _libraryTypes = require("../libraries/libraryTypes");
function handleLoad(library, state) {
  return (0, _ramda.pipe)((0, _ramda.assocPath)([library, 'loading'], true), (0, _ramda.assocPath)([library, 'toLoad'], false))(state);
}
function handleLoaded(library, state) {
  return (0, _ramda.pipe)((0, _ramda.assocPath)([library, 'loaded'], true), (0, _ramda.assocPath)([library, 'loading'], false))(state);
}
function librariesReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  switch (action.type) {
    case _libraryTypes.LibrariesActions.LOAD:
      return action.payload.libraries.reduce(function (acc, lib) {
        return handleLoad(lib, acc);
      }, state);
    case _libraryTypes.LibrariesActions.LOADED:
      return action.payload.libraries.reduce(function (acc, lib) {
        return handleLoaded(lib, acc);
      }, state);
    case _libraryTypes.LibrariesActions.TO_LOAD:
      return (0, _ramda.pipe)((0, _ramda.assocPath)([action.payload.library, 'toLoad'], true))(state);
    default:
      return state;
  }
}